/*
 *  Project   : tin - a Usenet reader / color-patch
 *  Module    : color.c
 *  Author    : Olaf Kaluza & Giuseppe De Marco
 *  Created   : 02-06-95
 *  Updated   : 22-04-96
 *  Notes     : This are the basic function for ansi-color
 *  Notes     : and word highlightning
 *  Copyright : Public Domain
 */

#include "tin.h"
#include "color.h"

/* setting foregroundcolor */
void fcol (int color)	
{
  if (!use_color) return;
  printf ("\033[%d;%dm", (color>>3), ((color&7)+30));
}

/* setting backgroundcolor */
void bcol (int color)	       
{
  if (!use_color) return;
  printf ("\033[%dm", (color+40));
}


/* Ein Blick in die zukunft :-(  */
int endtest(char *line, int start, char kind, int len)
{  int count;
   for(count=start+1;count<len;count++){
   if  (*(line+count)==kind) 
     {
      if (  (*(line+count+1)==' ') || 
            (*(line+count+1)==',') || 
            (*(line+count+1)=='.') || 
            (count==len-1) 
         ) return(1); 
         else return(0);
      }
   } 
   return(0);
}

/* recursive function for word-highlightning */
void highlight_printf(char *str1, char *line, int color)
{ int counter,counter2,end,len,start;
  char kind;
  char dummy[LEN+50];

  start=-1; 
  end=0; 
  len=strlen(line);

  /* test for special word beginning */
  for (counter=0; counter<len; counter++) { 
        if  (  ( (*(line+counter)=='*') || 
                 (*(line+counter)=='/') || 
                 (*(line+counter)=='_')  
                ) 
                && 
                (  ( (*(line+counter-1)==' ') || 
                      (counter==0) 
                    )   
                    &&  
                     (
                      (*(line+counter+1)!='*') && 
                      (*(line+counter+1)!='/') &&
                      (*(line+counter+1)!='_') 
                     )
                )
             ) 
            { if (endtest(line,counter,(*(line+counter)),len)) { 
                                 start=counter; 
                                 kind=*(line+counter); 
                                 break;}
            }
  }

  /* test for special word ending */
  for (counter=start; counter<len; counter++) {
         if ( (*(counter+line)==kind) && 
              (  (*(counter+line+1)==' ') ||
              (*(counter+line+1)==',') || 
              (*(counter+line+1)=='.') || 
              (counter==(len-1)) ) ) 
               { end=counter; break;}
  }

  /* highlightning word/area found? */
  if ((start>=0) && (end>start)) {
      strcpy(dummy,line);  /* print string before highlight */
      *(dummy+start)=0;
      printf("%s",dummy);

      strcpy(dummy,line+start+1);  /* highlightning word */
      *(dummy+((end-start)-1))=0;
      switch (kind) {
         case '*' : fcol(farbe15); break;
         case '/' : fcol(farbe16); break;
         case '_' : fcol(farbe17); break;
       }
      printf("%s",dummy);
      fcol(color);

      strcpy(dummy,line+end+1);   /* prepare the rest of the line */

      highlight_printf(str1,dummy,color); /* again and again and .... */

  }
  else
    {
     printf(str1,line);  /* the last normal part of a line */
  }
}






